open Global

let may_pick wa wm pa =
  let rec aux wa wm pa accu =
    match pa with
    | [] -> accu
    | p::rest -> 
	let w = p.weight in
	if wa + w < wm then
	  aux (wa + w) wm rest (p::accu)
	else
	  aux wa wm rest accu in
  aux wa wm pa []

let may_drop x y pl =
  let rec aux x y pl accu =
    match pl with
    | { going_x = x'; going_y = y'} as p :: rest when x = x' && y = y' ->
	aux x y rest (p::accu)
    | _ :: rest -> aux x y rest accu
    | [] -> accu in
  aux x y pl []

let rec make_mov x y =
  match Random.int 4 with
  | 0 -> 
      if game.(x + 1).(y) = Good then E
      else make_mov x y
  | 1 ->
      if game.(x - 1).(y) = Good then W
      else make_mov x y
  | 2 ->
      if game.(x).(y - 1) = Good then S
      else make_mov x y
  | 3 ->
      if game.(x).(y + 1) = Good then N
      else make_mov x y
  | _ -> assert false

let make_dec robot available =
  let drop = may_drop robot.position_x robot.position_y robot.carrying.carrying_package in
  if drop <> [] then
    Drop (List.map (fun {pid = id} -> id) drop)
  else
    let pick = may_pick robot.carrying.carryng_weight
		 robot.carrying.max_weight available in
    if pick <> [] then
      Pick (List.map (fun {pid = id} -> id) pick)
    else    
      Move (make_mov robot.position_x robot.position_y)
